#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>
#include<cstdio>
#include "lcd.h"

#define BUFSIZE 16
#define SIZE 3
#define THRESHOLD 512

void pulse_meter() {
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (1 << ADIE) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
 
    DDRD |= (1 << PD7);
    DDRD |= (1 << PD5);

    int val1 = 0, val2 = 0, pulse_value = 0;
    char* buf = (char*) malloc(sizeof(char) * BUFSIZE);
    int intervals[SIZE];
    int i = 0;

    while(1) {
        int adc_value;
        ADCSRA |= (1 << ADSC);
        while(ADCSRA & (1 << ADSC));
        adc_value = ADC;
        
        if (adc_value > THRESHOLD) {
            PORTD |= (1 << PD7);
            val1 = adc_value;
        } else {
            PORTD &= ~(1 << PD7);
	    val2 = adc_value;
        }
        if(val1 != 0 && val2 != 0) {
	    if (val1 > val2) {
	        intervals[i] = val1 - val2;
	    } else {
                intervals[i] = val2 - val1;
	    }
	    val1 = 0;
	    val2 = 0;
	    i++;
        }
	if(i == SIZE) {
	    for(int i=0; i<SIZE; i++)
		pulse_value += intervals[i];
	    pulse_value = pulse_value / SIZE;
	    sprintf(buf, "%d ",pulse_value);
	    LCD_print(buf);
	    return;
	}
    
    PORTD ^= (1 << PD5);
    _delay_ms(500);
    }
 
}
 
int main() {
    LCD_init();
    LCD_print("Pulse = ");
    pulse_meter();

    return 0;
}
